# stuff to be implemented externally:
Source10: kmodtool
%define kmodtool bash %{SOURCE10}
# end stuff to be ...

# hardcode for now:
%{!?kversion: %define kversion 2.6.21-1.3194.fc7}

%define kmod_name ivtv
%define kverrel %(%{kmodtool} verrel %{?kversion} 2>/dev/null)

%define upvar ""
%ifarch i686
%define paevar PAE
%endif
%ifarch ppc
%define smpvar smp
%endif
%{!?kvariants: %define kvariants %{?upvar} %{?smpvar} %{?paevar} %{?xenvar} %{?kdumpvar}}

Name:           ivtv-kmod
Version:        0.10.3
Release:        1.%(echo %{kverrel} | tr - _)
Summary:        Linux kernel module for ivtv

Group:          System Environment/Kernel
License:        GPL
URL:            http://ivtvdriver.org
Source0:        http://dl.ivtvdriver.org/ivtv/archive/0.10.x/ivtv-%{version}.tar.gz
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Requires:       ivtv-kmod-common >= %{version}

%description
Acer_acpi creates entries under /proc/acpi/acer, which enable you to control 
the wireless LAN card, inbuilt Bluetooth adapter, and mail LED of your laptop.

# magic hidden here:
%{expand:%(%{kmodtool} rpmtemplate %{kmod_name} %{kverrel} %{kvariants} 2>/dev/null)}


%prep
# to understand the magic better or to debug it, uncomment this:
#{kmodtool} rpmtemplate %{kmod_name} %{kverrel} %{kvariants} 2>/dev/null
#sleep 5
%setup -q -c
grep -rl 'kernel/drivers/media/video/ivtv' ivtv-%{version}/driver/Makefile \
| xargs perl -pi -e's,kernel/drivers/media/video/ivtv,extra/ivtv,'
grep -rl 'kernel/drivers/media/video' ivtv-%{version}/i2c-drivers/Makefile \
| xargs perl -pi -e's,kernel/drivers/media/video,extra/ivtv,'
grep -rl '/sbin/depmod -a' ivtv-%{version}/i2c-drivers/Makefile \
| xargs perl -pi -e's,/sbin/depmod -a,,'
grep -rl '/sbin/depmod -a' ivtv-%{version}/driver/Makefile \
| xargs perl -pi -e's,/sbin/depmod -a,,'

for kvariant in %{kvariants} ; do
  cp -a %{kmod_name}-%{version} _kmod_build_$kvariant
done


%build
for kvariant in %{kvariants}; do
ksrc=%{_usrsrc}/kernels/%{kverrel}${kvariant:+-$kvariant}-%{_target_cpu}
pushd _kmod_build_$kvariant
make -C driver \
        KDIR="${ksrc}" \
        KVER=%{kverrel}${kvariant}  
make -C i2c-drivers \
        KDIR="${ksrc}" \
        KVER=%{kverrel}${kvariant} 
popd
done

%install
rm -rf $RPM_BUILD_ROOT
for kvariant in %{kvariants}; do
ksrc=%{_usrsrc}/kernels/%{kverrel}${kvariant:+-$kvariant}-%{_target_cpu}
mkdir -p $RPM_BUILD_ROOT/lib/modules/%{kverrel}${kvariant}/extra/%{kmod_name}
pushd _kmod_build_$kvariant
make -C driver DESTDIR=$RPM_BUILD_ROOT \
        KDIR="${ksrc}" \
        KVER=%{kverrel}${kvariant}  install
make -C i2c-drivers DESTDIR=$RPM_BUILD_ROOT \
        KDIR="${ksrc}" \
        KVER=%{kverrel}${kvariant} install
popd
done

chmod u+x $RPM_BUILD_ROOT/lib/modules/*/extra/%{kmod_name}/*

%clean
rm -rf $RPM_BUILD_ROOT


%changelog
* Mon Jun 4 2007 kwizart < kwizart at gmail.com > - 0.10.3-1
- Update to 0.10.3

* Fri Mar 2 2007 kwizart < kwizart at gmail.com > - 0.10.1-1
- Update to 0.10.1

* Sat Jan 13 2007 kwizart < kwizart at gmail.com > - 0.9.1-1
- Update to 0.9.1 for kernel 2.6.19
- Requires firmwares

* Sat Jan 06 2007 kwizart < kwizart at gmail.com > - 0.8.2-1
- Initial Release.
